Gemini LLM Scraper API provides structured results from Gemini. The results are specific to the selected location (see the List of Locations) and language (see the List of Languages), and keyword.
There are two different priorities that stand for the relative speed of task execution: normal and high.
POST
Pricing
Your account will be charged only for setting a task.
The cost can be calculated on the Pricing page.
All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 10000 API calls per minute, with each POST call containing no more than 100 tasks. If your POST call contains over 100 tasks, the tasks over this limit will return the 40006 error.
You can retrieve the results of completed tasks using the unique task identifier id. Alternatively, we can send them to you as soon as they are ready if you specify the postback_url or pingback_url when setting a task. Note that if your server doesn’t respond within 10 seconds, the connection will be aborted by timeout, and the task will be transferred to the ‘Tasks Ready’ list. The error code and message depend on your server’s configuration.
See Help Center to learn more about using pingbacks and postbacks with DataForSEO APIs.
Below you will find a detailed description of the fields you can use for setting a task.
Description of the fields for setting a task:
Field name
Type
Description
keyword
string
keyword required field you can specify up to 2000 characters in the keyword field all %## will be decoded (plus character ‘+’ will be decoded to a space character) if you need to use the “%” character for your keyword, please specify it as “%25”; if you need to use the “+” character for your keyword, please specify it as “%2B”
learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article
priority
integer
task priority optional field can take the following values: 1 – normal execution priority (set by default) 2 – high execution priority You will be additionally charged for the tasks with high execution priority. The cost can be calculated on the Pricing page.
location_name
string
full name of search engine location required field if you don't specifylocation_code or location_coordinate if you use this field, you don't need to specify location_code or location_coordinate you can receive the list of available locations of the search engine with their location_name by making a separate request to the https://api.dataforseo.com/v3/ai_optimization/gemini/llm_scraper/locations example: United States
location_code
integer
search engine location code required field if you don't specifylocation_name or location_coordinate if you use this field, you don't need to specify location_name or location_coordinate you can receive the list of available locations of the search engines with their location_code by making a separate request to the https://api.dataforseo.com/v3/ai_optimization/gemini/llm_scraper/locations example: 2840
location_coordinate
string
GPS coordinates of a location
required field if you don't specifylocation_name or location_code
if you use this field, you don't need to specify location_name or location_code
location_coordinate parameter should be specified in the "latitude,longitude,radius" format
the maximum number of decimal digits for "latitude" and "longitude": 7
the minimum value for "radius": 199 (mm)
the maximum value for "radius": 199999 (mm)
example:
53.476225,-2.243572,200
language_name
string
full name of search engine language required field if you don't specify language_code; if you use this field, you don't need to specify language_code; you can receive the list of available languages of the search engine with their language_name by making a separate request to the https://api.dataforseo.com/v3/ai_optimization/gemini/llm_scraper/languages example: English
language_code
string
search engine language code required field if you don't specify language_name; if you use this field, you don't need to specify language_name; you can receive the list of available languages of the search engine with their language_code by making a separate request to the https://api.dataforseo.com/v3/ai_optimization/gemini/llm_scraper/languages example: en
expand_citations
boolean
return expanded citation bar in HTML results optional field when enabled, the HTML endpoint will return data from the expanded citation bar; default value: false
tag
string
user-defined task identifier optional field the character limit is 255 you can use this parameter to identify the task and match it with the result you will find the specified tag value in the data object of the response
postback_url
string
URL for sending task results optional field once the task is completed, we will send a POST request with its results compressed in the gzip format to the postback_url you specified you can use the ‘$id’ string as a $id variable and ‘$tag’ as urlencoded $tag variable. We will set the necessary values before sending the request. example: http://your-server.com/postbackscript?id=$id http://your-server.com/postbackscript?id=$id&tag=$tag Note: special characters in postback_url will be urlencoded; i.a., the # character will be encoded into %23
postback_url datatype required field if you specify postback_url corresponds to the function you used for setting a task possible values: advanced, html
pingback_url
string
notification URL of a completed task optional field when a task is completed we will notify you by GET request sent to the URL you have specified you can use the ‘$id’ string as a $id variable and ‘$tag’ as urlencoded $tag variable. We will set the necessary values before sending the request. example: http://your-server.com/pingscript?id=$id http://your-server.com/pingscript?id=$id&tag=$tag Note: special characters in pingback_url will be urlencoded; i.a., the # character will be encoded into %23
As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.
Description of the fields in the results array:
Field name
Type
Description
version
string
the current version of the API
status_code
integer
general status code you can find the full list of the response codes here Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions
status_message
string
general informational message you can find the full list of general informational messages here
time
string
execution time, seconds
cost
float
total tasks cost, USD
tasks_count
integer
the number of tasks in the tasksarray
tasks_error
integer
the number of tasks in the tasks array returned with an error
status code of the task generated by DataForSEO; can be within the following range: 10000-60000
status_message
string
informational message of the task
time
string
execution time, seconds
cost
float
cost of the task, USD
result_count
integer
number of elements in the result array
path
array
URL path
data
object
contains the same parameters that you specified in the POST request
result
array
array of results in this case, the value will be null
Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access
# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
login="login"
password="password"
cred="$(printf ${login}:${password} | base64)"
curl --location --request POST "https://api.dataforseo.com/v3/ai_optimization/gemini/llm_scraper/task_post"
--header "Authorization: Basic ${cred}"
--header "Content-Type: application/json"
--data-raw '[
{
"language_code": "en",
"location_code": 2840,
"keyword": "albert einstein"
}
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
try {
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');
} catch (RestClientException $e) {
echo "n";
print "HTTP code: {$e->getHttpCode()}n";
print "Error code: {$e->getCode()}n";
print "Message: {$e->getMessage()}n";
print $e->getTraceAsString();
echo "n";
exit();
}
$post_array = array();
// example #1 - a simple way to set a task
// this way requires you to specify a location, a language of search, and a keyword.
$post_array[] = array(
"language_code" => "en",
"location_code" => 2840,
"keyword" => mb_convert_encoding("albert einstein", "UTF-8")
);
// example #2 - a way to set a task with additional parameters
// high priority allows us to complete a task faster, but you will be charged more credits.
// after a task is completed, we will send a GET request to the address you specify. Instead of $id and $tag, you will receive actual values that are relevant to this task.
$post_array[] = array(
"language_name" => "English",
"location_name" => "United States",
"keyword" => mb_convert_encoding("albert einstein", "UTF-8"),
"priority" => 2,
"tag" => "some_string_123",
"pingback_url" => 'https://your-server.com/pingscript?id=$id&tag=$tag'
);
// this example has 2 elements, but in the case of a large number of tasks - send up to 100 elements per POST request
if (count($post_array) > 0) {
try {
// POST /v3/ai_optimization/gemini/llm_scraper/task_post
// in addition to 'chatgpt' and 'llm_scraper' you can also set other search engine and type parameters
// the full list of possible parameters is available in documentation
$result = $client->post('/v3/ai_optimization/gemini/llm_scraper/task_post', $post_array);
print_r($result);
// do something with post result
} catch (RestClientException $e) {
echo "n";
print "HTTP code: {$e->getHttpCode()}n";
print "Error code: {$e->getCode()}n";
print "Message: {$e->getMessage()}n";
print $e->getTraceAsString();
echo "n";
}
}
$client = null;
?>
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# example #1 - a simple way to set a task
# this way requires you to specify a location, a language of search, and a keyword.
post_data[len(post_data)] = dict(
language_code="en",
location_code=2840,
keyword="albert einstein"
)
# example #2 - a way to set a task with additional parameters
# high priority allows us to complete a task faster, but you will be charged more.
# after a task is completed, we will send a GET request to the address you specify. Instead of $id and $tag, you will receive actual values that are relevant to this task.
post_data[len(post_data)] = dict(
language_name="English",
location_name="United States",
keyword="albert einstein",
priority=2,
pingback_url="https://your-server.com/pingscript?id=$id&tag=$tag"
)
# POST /v3/ai_optimization/gemini/llm_scraper/task_post
# in addition to 'gemini' and 'llm_scraper' you can also set other search engine and type parameters
# the full list of possible parameters is available in documentation
response = client.post("/v3/ai_optimization/gemini/llm_scraper/task_post", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
print(response)
# do something with result
else:
print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
namespace DataForSeoDemos
{
public static partial class Demos
{
public static async Task ai_optimization_llm_scraper_task_post()
{
var httpClient = new HttpClient
{
BaseAddress = new Uri("https://api.dataforseo.com/"),
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
};
var postData = new List<object>();
// example #1 - a simple way to set a task
// this way requires you to specify a location, a language of search, and a keyword.
postData.Add(new
{
language_code = "en",
location_code = 2840,
keyword = "albert einstein"
});
// example #2 - a way to set a task with additional parameters
// high priority allows us to complete a task faster, but you will be charged more credits.
// after a task is completed, we will send a GET request to the address you specify. Instead of $id and $tag, you will receive actual values that are relevant to this task.
postData.Add(new
{
language_name = "English",
location_name = "United States",
keyword = "albert einstein",
priority = 2,
tag = "some_string_123",
pingback_url = "https://your-server.com/pingscript?id=$id&tag=$tag"
});
// POST /v3/ai_optimization/gemini/llm_scraper/task_post
// in addition to 'gemini' and 'llm_scraper' you can also set other search engine and type parameters
// the full list of possible parameters is available in documentation
var taskPostResponse = await httpClient.PostAsync("/v3/ai_optimization/gemini/llm_scraper/task_post", new StringContent(JsonConvert.SerializeObject(postData)));
var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
// you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if (result.status_code == 20000)
{
// do something with result
Console.WriteLine(result);
}
else
Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
}
}
}
The above command returns JSON structured like this: